/*  Development Environment:
	BC++ 3.1, DOS 5.0, Novell Netware 3.11,
	Novell Netware Client API 1.00e

	Thomas H. Smith  [70674,3300]

*/
#include <windows.h>
#include <stdlib.h>
#include <stdio.h>
#include <alloc.h>
#include <string.h>
#include <conio.h>
#include <dos.h>
#include <dir.h>
#include <direct.h>
#include <ctype.h>

#include <nwcalls.h>	// Netware include file


void			cleanup(void);

BOOL 			FForce = TRUE;

NWOBJ_TYPE		*objectType;
char 			*lpszMailDrvO;
NWOBJ_ID		*objectid;
char 			*lpszNetDrvO;
int				iCurrentDrive;

int mailchkw()
{
	NWCONN_HANDLE	connHandle;
	NWCONN_NUM	connNum;
	char		objectName[48];
	NWCCODE		ccode;
	BYTE		loginTime[7];
	CONNECT_INFO	connInfo;

	char	nw_pathsys[] 	= "SYS:";
	char	nw_maildir[12] 	= "MAIL\\";
	char	MailDir[8];
	char	*ptrMailDir;
	unsigned long 	UserNum;

	WORD	drvOstatus;
    NWCONN_HANDLE	OconnHandle;
	char	RootPath[65];
	char	RelPath[65];
	char	FullPath[120];

	struct	ffblk 	ffblk;
	int		MsgCount;
	int		done;
	int 	i;
	UINT	*iptrNetDrvO;
	UINT	iNetDrvO = 128;

	char 	*lpszDrvO = "O:";
	char 	*lpszCurrDrvO;
	char 	*lpszPassword = "\0";
    char 	*ptrMailDrv;

	ccode = NWCallsInit( NULL, NULL);
	if(ccode)
		return(-1);

/* Get defaut server connection handle */
	ccode = NWGetDefaultConnectionID( &connHandle );
	if(ccode)
    	return(-2);

/* Get server info - used to get server name */
	ccode = NWGetConnectionStatus( connHandle,
									&connInfo,
									sizeof(CONNECT_INFO));
	if(ccode)
    	return(-3);
/* Get connection handle */
	ccode = NWGetConnectionHandle( connInfo.serverName, 0, &connHandle, NULL );
	if(ccode)
		return(-4);

/* Get User ID - connection number needed to get user info */
	ccode = NWGetConnectionNumber( connHandle, &connNum );
	if(ccode)
		return (-5);

/* Allocate memory for user info and mail drive while at it */
	objectType = (NWOBJ_TYPE *)malloc(128);
	objectid = (NWOBJ_ID *)malloc(128);
	lpszMailDrvO = (char *)malloc(128);

	ccode = NWGetConnectionInformation( connHandle, connNum, objectName,
		  objectType, objectid, loginTime);
	if(ccode)
		return(-6);


	strcpy( lpszMailDrvO, connInfo.serverName);
	strcat( lpszMailDrvO, "\\" );
	strcat( lpszMailDrvO, nw_pathsys );
	strcat( lpszMailDrvO, nw_maildir );

	UserNum =  NWLongSwap( *objectid );

/* Change Hex to user directory Text */

	ultoa( UserNum, MailDir, 16);

	for (i=0; i<8; i++)
   	{
    	if(MailDir[i] > '9')
			MailDir[i] = toupper(MailDir[i]);
   	}

	ptrMailDir = MailDir;

	strncat( (char *)lpszMailDrvO, ptrMailDir, 8);

/* Get current drive. Change back to it later. */
	iCurrentDrive = _getdrive();

/* Go to local Drive to insure current drive isn't O: */
	_chdrive(3);

	ccode = _chdrive(15);
	if(ccode == 0)
	{
		_chdrive(3);

		/* Create association between integer
		and pointer for buffersize */
		iptrNetDrvO = &iNetDrvO;

		/* Allocate buffer memory
		for Drive O: setting */
		lpszNetDrvO=(char *)malloc(128);

		/* Get Drive O: setting - to lpszNetDrvO
		   Will fail if Drive O: has not been mapped */
		ccode = WNetGetConnection( lpszDrvO, lpszNetDrvO,
					(UINT FAR* )iptrNetDrvO);

    	if(ccode == 0)	/* if Drive O: is there, cancel (remove) it */
		{
			ccode = WNetCancelConnection( lpszDrvO, FForce);
			if( ccode )
			{
				cleanup();
				return(-7);
			}
		}
	}

/* Make drive O: */
	ccode = WNetAddConnection( (char *)lpszMailDrvO, lpszPassword,
					lpszDrvO );
	if(ccode){
		cleanup();
		return(-8);
	}

/* Attempt to change to drive O:  */
	ccode = _chdrive(15);
	if(ccode){
		cleanup();
		return(-9);
	}

/* Search for '*.CNM' message file  */
	done = findfirst("*.CNM", &ffblk, 0);
	if(done != 0)
		MsgCount=0;
	else
	{	 /* Mail message has been read if '!' is first character  */
		if( ffblk.ff_name[0] != '!' )
			MsgCount=1;
		else
			MsgCount=0;
	}
/* Count all *.CNM files without an ! for first character */
	while(done == 0 )
	{
		done = findnext( &ffblk );
		if(done)
			break;
		if( ffblk.ff_name[0] != '!' )
			MsgCount++;
	}

/* Delete drive O: */
	ccode = WNetCancelConnection( lpszDrvO, FForce);

/* Restore Drive O: if it was previously in use */

	if( strlen( (char *)lpszNetDrvO ) != 0)
	{
		ccode=WNetAddConnection((char *)lpszNetDrvO,
						lpszPassword, lpszDrvO );
	}
/* Complete success */
	cleanup();
	return( MsgCount);

}

void cleanup()
{
	_chdrive(iCurrentDrive);
	free(objectType);
	free(lpszMailDrvO);
    free(objectid);
	if(strlen(lpszNetDrvO) > 0)
		free(lpszNetDrvO);
}
